<template>
  <div class="material__style">
    <!-- Cuerpo -->
    <div style="margin: 0 4rem" class="padding-top">
      <el-header style="height: auto; margin: 0 2.75rem">
        <el-row :gutter="15">
          <!-- Filtros -->
          <el-col :span="20" :offset="5">
            <el-col :span="9">
              <app-select
                v-model="filterSelect"
                :filterArray="allFilters"
              ></app-select>
            </el-col>
            <el-col :span="11">
              <el-input
                class="input-head"
                placeholder="Buscar"
                prefix-icon="el-icon-search"
                v-model="textSearch"
                @clear="cleanSearch"
                @keyup.enter.native="filterMaterials"
                clearable
              ></el-input>
            </el-col>
            <el-col :span="2">
              <el-button
                @click="filterMaterials"
                type="primary"
                :disabled="textSearch == ''"
                >BUSCAR</el-button
              >
            </el-col>
          </el-col>
        </el-row>

        <!-- Subtítulo -->
        <el-col :span="24">
          <div class="titleSection">Lista de Materiales</div>
        </el-col>
        <!-- Botón nuevo -->
        <div class="text-end" style="margin-top: 3rem">
          <el-button @click="goToNewMaterial" type="primary"
            >NUEVO MATERIAL</el-button
          >
        </div>
      </el-header>

      <div v-loading="loading" :element-loading-text="loadingText">
        <!-- Tarjetas -->
        <el-row
          :class="[
            materials.length == 0 ? 'remove-grid-container' : 'grid-container',
          ]"
          v-if="materials && materials.length"
        >
          <el-col
            v-for="(material, index) in materials"
            style="margin-bottom: 4rem"
            :key="material.__id"
          >
            <app-cards
              v-if="material.canned == false"
              :principalTitle="material.originalTitle"
              :dataTable="materials[index].validityString"
              :showvalidity="false"
              :canned="material.canned"
              :textModal="textModal"
              :uniqueId="material.__id"
              :item="material"
              :editRoute="editRoute"
              @executeEdit="editMaterial($event, material)"
              @executeChangeStatus="statusChange(material)"
              :principalData="{
                0: {
                  class: 'bg-orange-ligth text-white',
                  subTitle: 'Cod. Material',
                  content: material.codMaterial,
                },
              }"
              :showSeason="material.numChapters"
              :positionSeason="'top'"
              :showAmounts="true"
              :emissionStatus="Object(material.reviewObj).emissionStatus"
              :rowsInfo="{
                0: {
                  hideWithChapters:
                    material.numChapters.length > 0 ? true : false,
                  left: {
                    subtitle: 'Duración d/ Programación',
                    content:
                      material.hoursMaterial +
                      'h ' +
                      material.minutesMaterial +
                      'min',
                  },
                },
                1: {
                  hideWithChapters: false,
                  left: {
                    subtitle: 'Tipo de Material',
                    content: material.stringMaterialType,
                  },
                  right: {
                    subtitle: 'Tipo de Contenido',
                    content: material.typeOfContent,
                  },
                },
                2: {
                  hideWithChapters: false,
                  left: {
                    subtitle: 'Centro de Costo',
                    content: material.costCenterName
                      ? `${material.costCenter} -  ${material.costCenterName}`
                      : material.costCenterName || material.costCenter,
                  },
                  right: {
                    subtitle: 'Género',
                    content:
                      generos(material).length > 0
                        ? generos(material).toString().replace(/,/gi, ', ')
                        : `Sin género asignado.`,
                  },
                },
                3: {
                  hideWithChapters:
                    material.numChapters.length > 0 ? false : true,
                  left: {
                    subtitle: 'Duración d/ Programación',
                    content:
                      material.hoursMaterial +
                      'h ' +
                      material.minutesMaterial +
                      'min',
                  },
                  right: {
                    subtitle: 'Canal de transmisión',
                    content: material.checkedChanels.join(', '),
                  },
                },
                4: {
                  hideWithChapters:
                    material.numChapters.length > 0 ? true : false,
                  left: {
                    subtitle: 'Canal de transmisión',
                    content: material.checkedChanels.join(', '),
                  },
                },
              }"
            />

            <app-cards
              v-else
              :principalTitle="material.originalTitle"
              :dataTable="materials[index].validityString"
              :showvalidity="true"
              :canned="material.canned"
              :textModal="textModal"
              :uniqueId="material.__id"
              :item="material"
              :routeCut="material"
              :editRoute="editRoute"
              @executeEdit="editMaterial($event, material)"
              @executeChangeStatus="statusChange(material)"
              :principalData="{
                0: {
                  class: 'bg-orange-ligth text-white',
                  subTitle: 'Cod. Material',
                  content: material.codMaterial,
                },
                1: {
                  class: 'bg-orange-ligth text-white',
                  subTitle: 'Cod. Géminis',
                  content: material.geminisCode,
                },
              }"
              :showSeason="material.numChapters"
              :positionSeason="'top'"
              :showAmounts="true"
              :showWindow="true"
              :emissionStatus="Object(material.reviewObj).emissionStatus"
              :showActors="Object(material.reviewObj)"
              :rowsInfo="{
                0: {
                  hideAfiliado:
                    material.stringMaterialType.search('Afiliación') !== -1,
                  left: {
                    subtitle: 'Duración s/ créditos',
                    content: Object(material.reviewObj).durWithoutCredits
                      ? convertHours(
                          Object(material.reviewObj).durWithoutCredits
                        )
                      : 'No ingresado',
                  },
                  right: {
                    subtitle: 'Duración d/ Programación',
                    content:
                      material.hoursMaterial +
                      'h ' +
                      material.minutesMaterial +
                      'min',
                  },
                },
                1: {
                  hideAfiliado: !(
                    material.stringMaterialType.search('Afiliación') !== -1
                  ),
                  left: {
                    subtitle: 'Duración d/ Programación',
                    content:
                      material.hoursMaterial +
                      'h ' +
                      material.minutesMaterial +
                      'min',
                  },
                  right: {
                    subtitle: 'Clasificación',
                    content: material.classification,
                  },
                },
                2: {
                  hideAfiliado: false,
                  left: {
                    subtitle: 'Tipo de Material',
                    content: material.stringMaterialType,
                  },
                  right: {
                    subtitle: 'Tipo de Contenido',
                    content: material.typeOfContent,
                  },
                },
                3: {
                  hideAfiliado: false,
                  left: {
                    subtitle: 'Centro de Costo',
                    content: material.costCenterName
                      ? `${material.costCenter} -  ${material.costCenterName}`
                      : material.costCenterName || material.costCenter,
                  },
                  right: {
                    subtitle: 'Género',
                    content:
                      generos(material).length > 0
                        ? generos(material).toString().replace(/,/gi, ', ')
                        : `Sin género asignado.`,
                  },
                },
                4: {
                  hideAfiliado:
                    material.stringMaterialType.search('Afiliación') !== -1,
                  left: {
                    subtitle: 'Clasificación',
                    content: material.classification,
                  },
                  right: {
                    subtitle: 'Canal de transmisión',
                    content: material.checkedChanels.join(', '),
                  },
                },
                5: {
                  hideAfiliado:
                    material.stringMaterialType.search('Afiliación') !== -1,
                  left: {
                    subtitle: 'Precio por pasada',
                    content:
                      material.broadcastPrice.length > 0
                        ? `${material.currencySymbol} ${material.broadcastPrice[0]}`
                        : 0,
                  },
                  right: {
                    subtitle: 'Saldo por pasadas',
                    content:
                      Number(material.totalPass) -
                      Number(material.pasadasConsumidas),
                  },
                },
                6: {
                  hideAfiliado: !(
                    material.stringMaterialType.search('Afiliación') !== -1
                  ),
                  left: {
                    subtitle: 'Canal de transmisión',
                    content: material.checkedChanels.join(', '),
                  },
                },
              }"
            />
          </el-col>
        </el-row>
        <!-- Tarjeta 'No hay resultado' -->
        <el-row class="grid-container" v-else>
          <el-col v-if="isShowNoResults">
            <el-card :body-style="{ padding: '0px' }" class="bg-gray">
              <el-col :span="8" style="margin-top: 1rem" class="text-center">
                <img src="@/assets/images/detective.svg" alt />
              </el-col>
              <el-col :span="16">
                <div style="margin-top: 5rem">
                  <p class="title-styles">¡Lo sentimos!</p>
                  <p class="title-styles">{{ existMaterial }}</p>
                </div>
              </el-col>
            </el-card>
          </el-col>
        </el-row>
      </div>
    </div>
  </div>
</template>

<script>
import Cards from '@/components/cards.vue'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { modifyText } from '@/utils/modifyText.js'
import { HTTP } from '@/main.js'
import { mapState } from 'vuex'

 /**
  * @vue-data {Array} allFilters - Filtros de busquedas de materiales
  * @vue-data {String} textSearch - Texto que hara el filtro
  * @vue-data {String} filterSelect - Tipo de filtro seleccionado
  * @vue-data {Array} allMaterials - Lista de todos los materiales
  * @vue-data {Array} searchMaterials - Lista de materiales filtrados
  * @vue-event {Array} generos - Retorna el nombre de todos los generos
  * @vue-computed {Array} materials - Lista de materiales filtrados o sin filtro
  */

export default {
  components: {
    'app-cards': Cards,
    'app-search-filter': SearchFilter,
    'app-select': Select,
  },
  data() {
    return {
      listGenders: [],
      textSearch: '',
      filterSelect: '',
      materialsInfo: [],
      allMaterials: [],
      searchMaterials: [],
      editRoute: 'newMaterial',
      textModal: 'material',
      allFilters: [
        { value: 'codMaterial', label: 'Código Material' },
        { value: 'genre', label: 'Género' },
        { value: 'startValidity', label: 'Vigencia - Inicio' },
        { value: 'endValidity', label: 'Vigencia - Fin' },
      ],
      loading: true,
      isShowNoResults: false,
      IsClick: false,
      existMaterial: 'No encontramos resultados para tu búsqueda',
    }
  },
  created() {
    this.$localStorage.set('materialId', JSON.stringify(''))
    this.getMaterial()
  },
  computed: {
    ...mapState({
      loadingText: (state) => state.textLoadingMaterial,
    }),
    materials() {
      return !this.IsClick ? this.allMaterials : this.searchMaterials
    },
  },
  methods: {
    generos(val) {
      let genero = val.genre || []
      // this.listGenders
      let nombres = []
      genero.forEach((el) => {
        this.listGenders.filter((e) => {
          if (el == e.code) {
            nombres.push(e.name)
          }
        })
      })

      return nombres
    },
    /** Se ejecuta la ruta desde el API para traer la lista de todos los materiales */
    async getMaterial() {
      this.loading = true
      try {
        const { data } = await HTTP.get('materials')
        if (data.materials && data.materials.length > 0) {
          this.allMaterials = data.materials
        } else {
          this.allMaterials = []
          this.isShowNoResults = true
          this.existMaterial = 'No existen Materiales disponibles'
        }
        this.loading = false
      } catch (err) {
        console.log({ err })
      }
    },
    /**Formatea el tiempo en horas, minutos y segundos*/
    convertHours(hours) {
      let newFormat = hours.split(':')
      let newF
      if (newFormat[0] == '') {
        newF = newFormat[1] + 'min ' + newFormat[2] + 's '
      } else {
        newF = newFormat[0] + 'h ' + newFormat[1] + 'min ' + newFormat[2] + 's '
      }
      return newF
    },
    goToNewMaterial() {
      this.$router.push({ name: 'newMaterial' })
    },
    /**Define el estado en que se encuentra el material*/
    statusChange(item) {
      const payload = {
        type: 'materials',
        id: item.__id,
        payloadInfo: item,
      }
      this.$store.dispatch('changeStatus', payload)
    },
    /**Envia a la vista para editar el material y trae todos los datos de este material
    * @param {String} event - No definido
    * @param {Object} material - Envia el objeto con todos los datos de ese material
    */
    editMaterial(event, material) {
      console.log(material)
      let targetId = event.target.parentElement.parentElement.id
      this.$localStorage.set('materialId', JSON.stringify(targetId))
      this.$localStorage.set('materialBag', JSON.stringify(material))
    },
    /**Hace el filtro de materiales dependiendo de con que se quiere filtrar*/
    filterMaterials() {
      let cadenaConexion
      if (
        this.filterSelect == 'startValidity' ||
        (this.filterSelect == 'endValidity' && this.textSearch !== '')
      ) {
        var myDate = this.textSearch
        myDate = myDate.split('/')
        var newDate = myDate[1] + '/' + myDate[0] + '/' + myDate[2]
        var timestamp = new Date(newDate).getTime()
        cadenaConexion = HTTP.get(
          `materials/typeOfFilter/${this.filterSelect}/word/${timestamp}`
        )
      } else if (this.filterSelect == '' && this.textSearch !== '') {
        cadenaConexion = HTTP.get(
          `materials/typeOfFilter/originalTitle/word/${this.textSearch}`
        )
      } else {
        cadenaConexion = HTTP.get(
          `materials/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`
        )
      }
      cadenaConexion.then((res) => {
        console.log(res, 'res')
        this.existMaterial = 'No encontramos resultados para tu búsqueda'
        this.isShowNoResults = res.data.materials.length == 0 ? true : false
        this.searchMaterials = res.data.materials
        this.IsClick = true
      })
    },
    cleanSearch() {
      this.filterSelect = ''
      this.isShowNoResults = false
      this.IsClick = false
    },
  },
  beforeDestroy() {
    this.$store.commit('updateTextMaterial', 'Cargando Materiales...')
  },
  mounted() {
    /**Se trae la lista de generos ni bien se carga la vista*/
    HTTP.get(`materials/list/genres`)
      .then((res) => {
        this.listGenders = res.data.listGenders
      })
      .catch((err) => {
        console.log(err)
      })
  },
}
</script>
<style scoped>
.material__style .titleSection {
  background: #4a4a4a;
  color: white;
  padding: 10px 10px 10px 35px;
  text-transform: uppercase;
  font-weight: 400;
  margin: 40px auto;
  font-size: 18px;
}
.material__style .grid-container-style {
  margin: 0px !important;
}
</style>